searchNodes=[{"doc":"Facade client for GraphQL requests The real backend must implement the execute/4 callback and must be configured by the :therealreal, GraphQL.Client, :backend application config.","ref":"GraphQL.Client.html","title":"GraphQL.Client","type":"behaviour"},{"doc":"Executes the given query, with the given variables and options.","ref":"GraphQL.Client.html#execute/3","title":"GraphQL.Client.execute/3","type":"function"},{"doc":"Callback spec for backend implementation","ref":"GraphQL.Client.html#c:execute_query/3","title":"GraphQL.Client.execute_query/3","type":"callback"},{"doc":"","ref":"GraphQL.Client.html#t:query/0","title":"GraphQL.Client.query/0","type":"type"},{"doc":"Functions to encode GraphQL.Query struct into a string","ref":"GraphQL.Encoder.html","title":"GraphQL.Encoder","type":"module"},{"doc":"Encodes a GraphQL.Query struct into a GraphQL query body","ref":"GraphQL.Encoder.html#encode/1","title":"GraphQL.Encoder.encode/1","type":"function"},{"doc":"","ref":"GraphQL.Encoder.html#encode_argument/1","title":"GraphQL.Encoder.encode_argument/1","type":"function"},{"doc":"","ref":"GraphQL.Encoder.html#encode_arguments/1","title":"GraphQL.Encoder.encode_arguments/1","type":"function"},{"doc":"A GraphQL.Client implementation that uses an Agent to store data, useful for tests.","ref":"GraphQL.LocalBackend.html","title":"GraphQL.LocalBackend","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"GraphQL.LocalBackend.html#child_spec/1","title":"GraphQL.LocalBackend.child_spec/1","type":"function"},{"doc":"Stores a response or a function that will be evaluated to the next call to execute_query","ref":"GraphQL.LocalBackend.html#expect/1","title":"GraphQL.LocalBackend.expect/1","type":"function"},{"doc":"","ref":"GraphQL.LocalBackend.html#start_link/0","title":"GraphQL.LocalBackend.start_link/0","type":"function"},{"doc":"Functions to create all different types of nodes of a GraphQL operation. Usually, this module should not be used directly, since it is easier to use the function from GraphQL.QueryBuilder .","ref":"GraphQL.Node.html","title":"GraphQL.Node","type":"module"},{"doc":"Creates a simple field, with no arguments or sub nodes. The name parameter can be an atom or string, or a two-element tuple with atoms or strings, where the first element is the actual name of the field and the second element is the alias of the field. GraphQL example A query with a simple field inside another field: query { user { id &lt;- -- - Simple field } } A query with a simple field with an alias: query { user { theId : id &lt;- -- - Simple field with alias } } Examples iex&gt; field ( :my_field ) % GraphQL.Node { node_type : :field , name : :my_field } iex&gt; field ( { :my_field , &quot;field_alias&quot; } ) % GraphQL.Node { node_type : :field , name : :my_field , alias : &quot;field_alias&quot; }","ref":"GraphQL.Node.html#field/1","title":"GraphQL.Node.field/1","type":"function"},{"doc":"Creates a field with arguments and sub nodes. The name parameter can be an atom or string, or a two-element tuple with atoms or strings, where the first element is the actual name of the field and the second element is the alias of the field. The arguments parameter is a map. The nodes argument is a list of %GraphQL.Node{} structs. GraphQL Example A query with a field that has arguments, an alias and subfields query { someObject : object ( slug : &quot;the-object&quot; ) { &lt;- -- -- Field with an alias and arguments field &lt;- -- -- Sub field anotherField &lt;- -- -- Sub field } } Examples iex&gt; field ( :my_field , %{ id : &quot;id&quot; } , [ field ( :subfield ) ] ) % GraphQL.Node { node_type : :field , name : :my_field , arguments : %{ id : &quot;id&quot; } , nodes : [ % GraphQL.Node { node_type : :field , name : :subfield } ] } iex&gt; field ( { :my_field , &quot;field_alias&quot; } , %{ id : &quot;id&quot; } , [ field ( :subfield ) ] ) % GraphQL.Node { node_type : :field , name : :my_field , alias : &quot;field_alias&quot; , arguments : %{ id : &quot;id&quot; } , nodes : [ % GraphQL.Node { node_type : :field , name : :subfield } ] }","ref":"GraphQL.Node.html#field/4","title":"GraphQL.Node.field/4","type":"function"},{"doc":"Creates a reference to a fragment. A fragment reference is used inside a field to import the fields of a fragment. GraphQL Example query { object { ... fieldsFromFragment &lt;- -- -- Fragment Reference } } Examples iex&gt; fragment ( &quot;myFields&quot; ) % GraphQL.Node { node_type : :fragment_ref , name : &quot;myFields&quot; }","ref":"GraphQL.Node.html#fragment/1","title":"GraphQL.Node.fragment/1","type":"function"},{"doc":"Creates a fragment. A fragment is used to share fields between other fields GraphQL Example query { object { ... fieldsFromFragment } } fragment fieldsFromFragment on Type { &lt;- -- -- - Fragment field1 field2 } Examples iex&gt; fragment ( &quot;myFields&quot; , &quot;SomeType&quot; , [ field ( :field ) ] ) % GraphQL.Node { node_type : :fragment , name : &quot;myFields&quot; , type : &quot;SomeType&quot; , nodes : [ % GraphQL.Node { node_type : :field , name : :field } ] }","ref":"GraphQL.Node.html#fragment/3","title":"GraphQL.Node.fragment/3","type":"function"},{"doc":"Creates an inline fragment. An inline fragment is used to conditionally add fields on another field depending on its type GraphQL Example query { object { ... on Type { &lt;- -- -- - Inline Fragment field1 field2 } } } Examples iex&gt; inline_fragment ( &quot;SomeType&quot; , [ field ( :field ) ] ) % GraphQL.Node { node_type : :inline_fragment , type : &quot;SomeType&quot; , nodes : [ % GraphQL.Node { node_type : :field , name : :field } ] }","ref":"GraphQL.Node.html#inline_fragment/2","title":"GraphQL.Node.inline_fragment/2","type":"function"},{"doc":"A GraphQL identifier that is not a GraphQL keyword (like mutation, query and fragment) Used to identify fields, aliases and fragments.","ref":"GraphQL.Node.html#t:name/0","title":"GraphQL.Node.name/0","type":"type"},{"doc":"A two-element tuple where the first position is the name of the field and the second element is the alias of the field.","ref":"GraphQL.Node.html#t:name_and_alias/0","title":"GraphQL.Node.name_and_alias/0","type":"type"},{"doc":"The GraphQL query element that this node represents. The four node types are: field: a single field of a GraphQL schema, may have arguments and other nodes fragment_ref: a reference to a fragment, used inside fields to import fragment fields fragment: a fragment definition, with name, type and fields inline_fragment: much like a fragment, but being inline, it does not need a name","ref":"GraphQL.Node.html#t:node_type/0","title":"GraphQL.Node.node_type/0","type":"type"},{"doc":"A struct representing a GraphQL operation node. A %Node{} struct can be represent a field, a fragment, an inline fragment or a fragment reference, identified by the :node_type field. The name represents how this node is identified within the GraphQL operation. The alias is only used when the :node_type is :field , and as the name suggests, represents the alias of the field's name. The arguments is a map with all the arguments used by a node, and it's only valid when thew :node_type is :field . The type is only used when :node_type is :fragment or :inline_fragment , and represents the GraphQL type of the fragment. The nodes is a list of child nodes, that can used to query for complex objects. The directives field is an enum with all the graphQL directives to be applied on a node node.","ref":"GraphQL.Node.html#t:t/0","title":"GraphQL.Node.t/0","type":"type"},{"doc":"Functions to create and modify query representations.","ref":"GraphQL.Query.html","title":"GraphQL.Query","type":"module"},{"doc":"Adds a field to a query. The field argument must be a GraphQL.Node struct and its :node_type must be :field . Examples iex&gt; f1 = GraphQL.Node . field ( :field ) % GraphQL.Node { node_type : :field , name : :field } iex&gt; f2 = GraphQL.Node . field ( :other_field ) % GraphQL.Node { node_type : :field , name : :other_field } iex&gt; q = % GraphQL.Query { operation : :query , name : &quot;MyQuery&quot; , fields : [ f1 ] } % GraphQL.Query { operation : :query , name : &quot;MyQuery&quot; , fields : [ f1 ] } iex&gt; add_field ( q , f2 ) % GraphQL.Query { name : &quot;MyQuery&quot; , operation : :query , fields : [ f2 , f1 ] }","ref":"GraphQL.Query.html#add_field/2","title":"GraphQL.Query.add_field/2","type":"function"},{"doc":"Adds a fragment to a query. The field argument must be a GraphQL.Node struct and its :node_type must be :field . Examples iex&gt; f1 = GraphQL.Node . fragment ( &quot;personFields&quot; , &quot;Person&quot; , [ GraphQL.Node . field ( :field ) ] ) % GraphQL.Node { node_type : :fragment , name : &quot;personFields&quot; , type : &quot;Person&quot; , nodes : [ % GraphQL.Node { node_type : :field , name : :field } ] } iex&gt; f2 = GraphQL.Node . fragment ( &quot;userFields&quot; , &quot;User&quot; , [ GraphQL.Node . field ( :another_field ) ] ) % GraphQL.Node { node_type : :fragment , name : &quot;userFields&quot; , type : &quot;User&quot; , nodes : [ % GraphQL.Node { node_type : :field , name : :another_field } ] } iex&gt; q = % GraphQL.Query { operation : :query , name : &quot;MyQuery&quot; , fields : [ ] , fragments : [ f1 ] } % GraphQL.Query { operation : :query , name : &quot;MyQuery&quot; , fields : [ ] , fragments : [ f1 ] } iex&gt; add_fragment ( q , f2 ) % GraphQL.Query { name : &quot;MyQuery&quot; , operation : :query , fields : [ ] , fragments : [ f2 , f1 ] }","ref":"GraphQL.Query.html#add_fragment/2","title":"GraphQL.Query.add_fragment/2","type":"function"},{"doc":"Add a new variable to an existing query Examples iex&gt; v1 = % GraphQL.Variable { name : &quot;id&quot; , type : &quot;Integer&quot; } % GraphQL.Variable { name : &quot;id&quot; , type : &quot;Integer&quot; } iex&gt; v2 = % GraphQL.Variable { name : &quot;slug&quot; , type : &quot;String&quot; } % GraphQL.Variable { name : &quot;slug&quot; , type : &quot;String&quot; } iex&gt; q = % GraphQL.Query { operation : :query , name : &quot;MyQuery&quot; , fields : [ ] , variables : [ v1 ] } % GraphQL.Query { operation : :query , name : &quot;MyQuery&quot; , fields : [ ] , variables : [ v1 ] } iex&gt; add_variable ( q , v2 ) % GraphQL.Query { operation : :query , name : &quot;MyQuery&quot; , fields : [ ] , variables : [ v2 , v1 ] }","ref":"GraphQL.Query.html#add_variable/2","title":"GraphQL.Query.add_variable/2","type":"function"},{"doc":"Combine two queries into one query, merging fields, variables and fragments. The two queries must have the same operation.","ref":"GraphQL.Query.html#merge/3","title":"GraphQL.Query.merge/3","type":"function"},{"doc":"Combines a list of queries into one query, merging fields, variables and fragments. All queries must have the same operation.","ref":"GraphQL.Query.html#merge_many/2","title":"GraphQL.Query.merge_many/2","type":"function"},{"doc":"Creates a new query struct for a 'mutation' operation from a keyword list.","ref":"GraphQL.Query.html#mutation/1","title":"GraphQL.Query.mutation/1","type":"function"},{"doc":"Creates a new query struct for a 'query' operation from a keyword list.","ref":"GraphQL.Query.html#query/1","title":"GraphQL.Query.query/1","type":"function"},{"doc":"A struct that represents a GraphQL query or mutation. The :operation field can be :query , for a query operation, or :mutation , for a mutation operation. The :name field is the name of the query or mutation. GraphQL does not require a name for operations, but this struct will enforce its presence in order to enrich trace and logging information. The :fields field is a list of GraphQL.Node structs. This the list of roof fields of a query or mutation. The :fragments field is also a list of GraphQL.Node structs, but intended to only keep fragment nodes, as they are usually placed after the root fields in a typical GraphQL query/mutation. The :variables fields is a list of GraphQL.Variable structs, that represents the expected variables during the request. Note that this list is the definition of variables, not the values of them.","ref":"GraphQL.Query.html#t:t/0","title":"GraphQL.Query.t/0","type":"type"},{"doc":"Functions to simplify the creation of GraphQL queries. The easiest way to use these functions is to import this module directly, this way you'll have all you need to build a query. Helper functions query/4 - creates a new &quot;query&quot; operation mutation/4 - creates a new &quot;mutation&quot; operation field/3 - creates a new field (optionals: variables and subfields) fragment/1 - creates a reference to a fragment fragment/3 - creates a fragment inline_fragment/2 - creates an inline fragment Writing queries and mutations As an example, consider the following GraphQL request: query UserQuery ( $ id : Integer = 1 ) { user ( id : $ id ) { id email ... personFields } } fragment personField on Person { firstName lastName } Using the functions in this module, you can create a representation of this query in this way: q = query ( &quot;UserQuery&quot; , %{ id : { &quot;Integer&quot; , 1 } } , [ field ( :user , %{ } , [ field ( :id ) field ( :email ) , fragment ( &quot;personFields&quot; ) ] ) ] , [ fragment ( &quot;personFields&quot; , &quot;Person&quot; , [ field ( &quot;firstName&quot; ) , field ( &quot;lastName&quot; ) ] ) ] )","ref":"GraphQL.QueryBuilder.html","title":"GraphQL.QueryBuilder","type":"module"},{"doc":"Creates a field. When rendered, it will have the following body: A simple field, no arguments or sub fields fieldName A field with an alias fieldAlias : fieldName A field with arguments fieldName ( arg : value ) A field with sub fields fieldName { subField } A field an alias, arguments and sub fields fieldAlias : fieldName ( arg : value ) { subField } Examples iex&gt; field ( :some_field ) % GraphQL.Node { node_type : :field , name : :some_field } iex&gt; field ( { :some_field , &quot;fieldAlias&quot; } ) % GraphQL.Node { node_type : :field , name : :some_field , alias : &quot;fieldAlias&quot; } iex&gt; field ( &quot;anotherField&quot; , %{ } , [ field ( :id ) ] ) % GraphQL.Node { node_type : :field , name : &quot;anotherField&quot; , nodes : [ % GraphQL.Node { node_type : :field , name : :id } ] }","ref":"GraphQL.QueryBuilder.html#field/4","title":"GraphQL.QueryBuilder.field/4","type":"function"},{"doc":"Creates a reference to a fragment. Use it inside a field. When rendered, it will generate the following body: ... fragmentName Examples iex&gt; fragment ( :fields ) % GraphQL.Node { node_type : :fragment_ref , name : :fields }","ref":"GraphQL.QueryBuilder.html#fragment/1","title":"GraphQL.QueryBuilder.fragment/1","type":"function"},{"doc":"Creates a fragment. Use it on the query level. When rendered, it will generate the following body: ... fragmentName on Type { field1 field2 } Examples iex&gt; fragment ( &quot;personFields&quot; , &quot;Person&quot; , [ field ( :name ) ] ) % GraphQL.Node { node_type : :fragment , name : &quot;personFields&quot; , type : &quot;Person&quot; , nodes : [ % GraphQL.Node { node_type : :field , name : :name } ] }","ref":"GraphQL.QueryBuilder.html#fragment/3","title":"GraphQL.QueryBuilder.fragment/3","type":"function"},{"doc":"Creates an inline fragment. Use it inside a field. When rendered, it will generate the following body: ... on Type { field1 field2 } Examples iex&gt; inline_fragment ( &quot;Person&quot; , [ field ( :name ) ] ) % GraphQL.Node { node_type : :inline_fragment , type : &quot;Person&quot; , nodes : [ % GraphQL.Node { node_type : :field , name : :name } ] }","ref":"GraphQL.QueryBuilder.html#inline_fragment/2","title":"GraphQL.QueryBuilder.inline_fragment/2","type":"function"},{"doc":"Creates a new GraphQL.Query struct, for a :mutation operation","ref":"GraphQL.QueryBuilder.html#mutation/4","title":"GraphQL.QueryBuilder.mutation/4","type":"function"},{"doc":"Creates a new GraphQL.Query struct, for a :query operation.","ref":"GraphQL.QueryBuilder.html#query/4","title":"GraphQL.QueryBuilder.query/4","type":"function"},{"doc":"Creates a GraphQL.Variable struct.","ref":"GraphQL.QueryBuilder.html#var/3","title":"GraphQL.QueryBuilder.var/3","type":"function"},{"doc":"Functions to handle query registries. A query registry stores several GraphQL.Query structs, so they can be combined into a single query before the execution.","ref":"GraphQL.QueryRegistry.html","title":"GraphQL.QueryRegistry","type":"module"},{"doc":"Add a query to the a query registry","ref":"GraphQL.QueryRegistry.html#add_query/3","title":"GraphQL.QueryRegistry.add_query/3","type":"function"},{"doc":"Add a new resolver into a query registry","ref":"GraphQL.QueryRegistry.html#add_resolver/2","title":"GraphQL.QueryRegistry.add_resolver/2","type":"function"},{"doc":"Add a list of resolvers into a query registry","ref":"GraphQL.QueryRegistry.html#add_resolvers/2","title":"GraphQL.QueryRegistry.add_resolvers/2","type":"function"},{"doc":"Executes the given query registry, using the given accumulator acc and the given options","ref":"GraphQL.QueryRegistry.html#execute/3","title":"GraphQL.QueryRegistry.execute/3","type":"function"},{"doc":"Creates a new QueryRegistry struct with the given name.","ref":"GraphQL.QueryRegistry.html#new/1","title":"GraphQL.QueryRegistry.new/1","type":"function"},{"doc":"A resolver is a function that must accept two arguments: a GraphQL.Response struct an accumulator, that can be of any type It also must return the updated value of the accumulator.","ref":"GraphQL.QueryRegistry.html#t:resolver/0","title":"GraphQL.QueryRegistry.resolver/0","type":"type"},{"doc":"A struct that keeps the information about several queries, variables and resolvers. The name field will be used as the name of the final query or mutation. The queries field is a list of GraphQL.Query structs, that will be merged before execution. The variables is a map with all values of variables that will be sent to the server along with the GraphQL body. The resolver is a list of t:resolver() functions that can be used to produce the side effects in an accumulator.","ref":"GraphQL.QueryRegistry.html#t:t/0","title":"GraphQL.QueryRegistry.t/0","type":"type"},{"doc":"Functions to handle GraphQL responses","ref":"GraphQL.Response.html","title":"GraphQL.Response","type":"module"},{"doc":"Creates a new failure response with the given errors Examples iex&gt; failure ( [ %{ message : &quot;some error&quot; , locations : [ %{ line : 2 , column : 5 } ] } ] ) % GraphQL.Response { success? : false , errors : [ %{ message : &quot;some error&quot; , locations : [ %{ line : 2 , column : 5 } ] } ] }","ref":"GraphQL.Response.html#failure/1","title":"GraphQL.Response.failure/1","type":"function"},{"doc":"Create a new partial success response with the given data and errors Examples iex&gt; data = %{ field : &quot;value&quot; } %{ field : &quot;value&quot; } iex&gt; errors = [ %{ message : &quot;some error&quot; , locations : [ %{ line : 2 , column : 5 } ] } ] [ %{ message : &quot;some error&quot; , locations : [ %{ line : 2 , column : 5 } ] } ] iex&gt; partial_success ( data , errors ) % GraphQL.Response { success? : :partial , data : %{ field : &quot;value&quot; } , errors : [ %{ message : &quot;some error&quot; , locations : [ %{ line : 2 , column : 5 } ] } ] }","ref":"GraphQL.Response.html#partial_success/2","title":"GraphQL.Response.partial_success/2","type":"function"},{"doc":"Creates a succes response with the given data Examples iex&gt; success ( %{ field : &quot;value&quot; } ) % GraphQL.Response { success? : true , data : %{ field : &quot;value&quot; } }","ref":"GraphQL.Response.html#success/1","title":"GraphQL.Response.success/1","type":"function"},{"doc":"A struct that contains the GraphQL response data.","ref":"GraphQL.Response.html#t:t/0","title":"GraphQL.Response.t/0","type":"type"},{"doc":"A struct to represent GraphQL variables","ref":"GraphQL.Variable.html","title":"GraphQL.Variable","type":"module"},{"doc":"A GraphQL generic name","ref":"GraphQL.Variable.html#t:name/0","title":"GraphQL.Variable.name/0","type":"type"},{"doc":"A struct that represents the definition of a GraphQL variable. A variable definition exists within a query or mutation, and then can be referenced by the arguments of fields.","ref":"GraphQL.Variable.html#t:t/0","title":"GraphQL.Variable.t/0","type":"type"},{"doc":"Graphql Client A client-side GraphQL library.","ref":"readme.html","title":"README","type":"extras"},{"doc":"Add graphql_client to you list of dependencies: def deps do [ { :graphql_client , &quot;~&gt; 0.1&quot; } ] end Creating a backend Now, you need to implement the GraphQL.Client behaviour: defmodule MyClient do @behaviour GraphQL.Client def execute_query ( query , variables , options ) do # your implementation end end Configuring the client In your configuration, set it as your backend: config :graphql_client , backend : MyClient Now, any call to GraphQL.Client will use the configured backend.","ref":"readme.html#installation","title":"README - Installation","type":"extras"},{"doc":"GraphQL as code To build queries, you can import all functions from GraphQL.QueryBuilder . A simple query, like this one: query User($slug: String! = &quot;*&quot;){ user(slug: $slug){ id email } Can be built using the following snippet: import GraphQL.QueryBuilder user_query = query ( &quot;User&quot; , %{ slug : { &quot;String!&quot; } , &quot;*&quot; } , [ field ( :user , %{ slug : :&quot;$slug&quot; } , [ field ( :id ) , field ( :email ) ] ) ] ) Now, the user_query variable contains a representation of this GraphQL operation. If you inspect it, you'll see this: % GraphQL.Query { fields : [ % GraphQL.Node { alias : nil , arguments : %{ slug : :&quot;$slug&quot; } , name : :user , node_type : :field , nodes : [ % GraphQL.Node { alias : nil , arguments : nil , name : :id , node_type : :field , nodes : nil , type : nil } , % GraphQL.Node { alias : nil , arguments : nil , name : :email , node_type : :field , nodes : nil , type : nil } ] , type : nil } ] , fragments : [ ] , name : &quot;User&quot; , operation : :query , variables : [ % GraphQL.Variable { default_value : &quot;*&quot; , name : :slug , type : &quot;String!&quot; } ] } But most of the time you'll not need to handle this directly. Executing queries To execute this query, you can now call the GraphQL.Client and use this query directly: GraphQL.Client . execute ( user_query , %{ slug : &quot;some-user&quot; } ) From the POV of the code that it's calling, it doesn't know if this client is using HTTP, smoke signals or magic. All you know is that this function will always return a %GraphQL.Response{} struct. To get the actual text body, you can use GraphQL.Encoder.encode/1 function: iex&gt; user_query |&gt; GraphQL.Encoder . encode ( ) |&gt; IO . puts ( ) query User ( $ slug : String ! = &quot;*&quot; ) { user ( slug : $ slug ) { id email } } :ok The Query Registry The end goal is to merge different queries into one operation and the query registry does exactly that. It will accumulate queries, variables and resolvers (yes, resolvers!), merge them, and then execute resolvers with an accumulator. user_query = query ( ... ) product_query = query ( ... ) user_resolver = fn response , acc -&gt; # do something with the response and return the updated accumulator updated_acc end registry = QueryRegistry . new ( &quot;BigQuery&quot; ) result = registry |&gt; QueryRegistry . add_query ( user_query , user_variables , [ user_resolver ] ) |&gt; QueryRegistry . add_query ( product_query , product_variables ) |&gt; QueryRegistry . execute ( %{ } , options ) A resolver function must accept two parameters: a %GraphQL.Response{} struct and the accumulator defined by the query registry. Testing The %GraphQL.Response{} is the only thing clients must return, and that we can configure the backend via config files. Internally, during tests, the backend will be changed to LocalBackend , that uses an Agent process to store responses. Call GraphQL.LocalBackend.start_link/0 on your test_helper.exs file. Now you can use the GraphQL.LocalBackend.expect/1 function: import GraphQL.LocalBackend , only : [ expect : 1 ] alias GraphQL.Response test &quot;my test&quot; do my_registry = QueryRegistry . new ( ... ) response = Response . success ( %{ field : &quot;value&quot; } ) expect ( my_registry , response ) assert 1 == 1 end If you need to inspect and assert the query and variables, you can pass a function: import GraphQL.LocalBackend , only : [ expect : 1 ] alias GraphQL.Response test &quot;my test&quot; do my_registry = QueryRegistry . new ( ... ) expect ( my_registry , fn query , _variables , _options -&gt; assert query == expected_query Response . success ( %{ field : &quot;value&quot; } ) end ) assert 1 == 1 end","ref":"readme.html#usage","title":"README - Usage","type":"extras"},{"doc":"This project Contributor Covenant version 2.1. Check CODE_OF_CONDUCT.md file for more information.","ref":"readme.html#code-of-conduct","title":"README - Code of Conduct","type":"extras"},{"doc":"graphql_client source code is released under Apache License 2.0. Check NOTICE and LICENSE files for more information.","ref":"readme.html#license","title":"README - License","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"First version! 1. New Features GraphQL query representation using elixir code! Merge queries into a single operation Testing suppport","ref":"changelog.html#v0-1-0","title":"Changelog - v0.1.0","type":"extras"},{"doc":"","ref":"code_of_conduct.html","title":"Code of Conduct","type":"extras"},{"doc":"We as members, contributors, and leaders pledge to make participation in our community a harassment-free experience for everyone, regardless of age, body size, visible or invisible disability, ethnicity, sex characteristics, gender identity and expression, level of experience, education, socio-economic status, nationality, personal appearance, race, caste, color, religion, or sexual identity and orientation. We pledge to act and interact in ways that contribute to an open, welcoming, diverse, inclusive, and healthy community.","ref":"code_of_conduct.html#our-pledge","title":"Code of Conduct - Our Pledge","type":"extras"},{"doc":"Examples of behavior that contributes to a positive environment for our community include: Demonstrating empathy and kindness toward other people Being respectful of differing opinions, viewpoints, and experiences Giving and gracefully accepting constructive feedback Accepting responsibility and apologizing to those affected by our mistakes, and learning from the experience Focusing on what is best not just for us as individuals, but for the overall community Examples of unacceptable behavior include: The use of sexualized language or imagery, and sexual attention or advances of any kind Trolling, insulting or derogatory comments, and personal or political attacks Public or private harassment Publishing others' private information, such as a physical or email address, without their explicit permission Other conduct which could reasonably be considered inappropriate in a professional setting","ref":"code_of_conduct.html#our-standards","title":"Code of Conduct - Our Standards","type":"extras"},{"doc":"Community leaders are responsible for clarifying and enforcing our standards of acceptable behavior and will take appropriate and fair corrective action in response to any behavior that they deem inappropriate, threatening, offensive, or harmful. Community leaders have the right and responsibility to remove, edit, or reject comments, commits, code, wiki edits, issues, and other contributions that are not aligned to this Code of Conduct, and will communicate reasons for moderation decisions when appropriate.","ref":"code_of_conduct.html#enforcement-responsibilities","title":"Code of Conduct - Enforcement Responsibilities","type":"extras"},{"doc":"This Code of Conduct applies within all community spaces, and also applies when an individual is officially representing the community in public spaces. Examples of representing our community include using an official e-mail address, posting via an official social media account, or acting as an appointed representative at an online or offline event.","ref":"code_of_conduct.html#scope","title":"Code of Conduct - Scope","type":"extras"},{"doc":"Instances of abusive, harassing, or otherwise unacceptable behavior may be reported to the community leaders responsible for enforcement at engineering@therealreal.com. All complaints will be reviewed and investigated promptly and fairly. All community leaders are obligated to respect the privacy and security of the reporter of any incident.","ref":"code_of_conduct.html#enforcement","title":"Code of Conduct - Enforcement","type":"extras"},{"doc":"Community leaders will follow these Community Impact Guidelines in determining the consequences for any action they deem in violation of this Code of Conduct: 1. Correction Community Impact : Use of inappropriate language or other behavior deemed unprofessional or unwelcome in the community. Consequence : A private, written warning from community leaders, providing clarity around the nature of the violation and an explanation of why the behavior was inappropriate. A public apology may be requested. 2. Warning Community Impact : A violation through a single incident or series of actions. Consequence : A warning with consequences for continued behavior. No interaction with the people involved, including unsolicited interaction with those enforcing the Code of Conduct, for a specified period of time. This includes avoiding interactions in community spaces as well as external channels like social media. Violating these terms may lead to a temporary or permanent ban. 3. Temporary Ban Community Impact : A serious violation of community standards, including sustained inappropriate behavior. Consequence : A temporary ban from any sort of interaction or public communication with the community for a specified period of time. No public or private interaction with the people involved, including unsolicited interaction with those enforcing the Code of Conduct, is allowed during this period. Violating these terms may lead to a permanent ban. 4. Permanent Ban Community Impact : Demonstrating a pattern of violation of community standards, including sustained inappropriate behavior, harassment of an individual, or aggression toward or disparagement of classes of individuals. Consequence : A permanent ban from any sort of public interaction within the community.","ref":"code_of_conduct.html#enforcement-guidelines","title":"Code of Conduct - Enforcement Guidelines","type":"extras"},{"doc":"This Code of Conduct is adapted from the Contributor Covenant , version 2.1, available at https://www.contributor-covenant.org/version/2/1/code_of_conduct.html . Community Impact Guidelines were inspired by Mozilla's code of conduct enforcement ladder . For answers to common questions about this code of conduct, see the FAQ at https://www.contributor-covenant.org/faq . Translations are available at https://www.contributor-covenant.org/translations .","ref":"code_of_conduct.html#attribution","title":"Code of Conduct - Attribution","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS Copyright (c) 2021, TheRealReal. Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"License","type":"extras"},{"doc":"Copyright 2022 TheRealReal Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at https://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"notice.html","title":"Notice","type":"extras"}]